---
title: Send a deployment event
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Delivery Performance
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Send a deployment event{% #send-a-deployment-event %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                              |
| ----------------- | --------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/dora/deployment |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/dora/deployment |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/dora/deployment      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/dora/deployment      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/dora/deployment  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/dora/deployment |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/dora/deployment     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/dora/deployment |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/dora/deployment |

### Overview



Use this API endpoint to provide deployment data.

This is necessary for:

- Deployment Frequency
- Change Lead Time
- Change Failure Rate
- Failed Deployment Recovery Time



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                            | Type     | Description                                                                                                                                                      |
| ------------ | -------------------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]           | object   | The JSON:API data.                                                                                                                                               |
| data         | attributes [*required*]     | object   | Attributes to create a DORA deployment event.                                                                                                                    |
| attributes   | custom_tags                      | [string] | A list of user-defined tags. The tags must follow the `key:value` pattern. Up to 100 may be added per event.                                                     |
| attributes   | env                              | string   | Environment name to where the service was deployed.                                                                                                              |
| attributes   | finished_at [*required*]    | int64    | Unix timestamp when the deployment finished. It must be in nanoseconds, milliseconds, or seconds.                                                                |
| attributes   | git                              | object   | Git info for DORA Metrics events.                                                                                                                                |
| git          | commit_sha [*required*]     | string   | Git Commit SHA.                                                                                                                                                  |
| git          | repository_url [*required*] | string   | Git Repository URL                                                                                                                                               |
| attributes   | id                               | string   | Deployment ID. Must be 16-128 characters and contain only alphanumeric characters, hyphens, underscores, periods, and colons (a-z, A-Z, 0-9, -, _, ., :).        |
| attributes   | service [*required*]        | string   | Service name.                                                                                                                                                    |
| attributes   | started_at [*required*]     | int64    | Unix timestamp when the deployment started. It must be in nanoseconds, milliseconds, or seconds.                                                                 |
| attributes   | team                             | string   | Name of the team owning the deployed service. If not provided, this is automatically populated with the team associated with the service in the Service Catalog. |
| attributes   | version                          | string   | Version to correlate with [APM Deployment Tracking](https://docs.datadoghq.com/tracing/services/deployment_tracking.md).                                         |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "finished_at": 1693491984000000000,
      "git": {
        "commit_sha": "66adc9350f2cc9b250b69abddab733dd55e1a588",
        "repository_url": "https://github.com/organization/example-repository"
      },
      "service": "shopist",
      "started_at": 1693491974000000000,
      "version": "v1.12.07"
    }
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response after receiving a DORA deployment event.

| Parent field | Field                  | Type   | Description                                                                      |
| ------------ | ---------------------- | ------ | -------------------------------------------------------------------------------- |
|              | data [*required*] | object | The JSON:API data.                                                               |
| data         | id [*required*]   | string | The ID of the received DORA deployment event.                                    |
| data         | type                   | enum   | JSON:API type for DORA deployment events. Allowed enum values: `dora_deployment` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "id": "4242fcdd31586083",
    "type": "dora_deployment"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="202" %}
OK - but delayed due to incident
{% tab title="Model" %}
Response after receiving a DORA deployment event.

| Parent field | Field                  | Type   | Description                                                                      |
| ------------ | ---------------------- | ------ | -------------------------------------------------------------------------------- |
|              | data [*required*] | object | The JSON:API data.                                                               |
| data         | id [*required*]   | string | The ID of the received DORA deployment event.                                    |
| data         | type                   | enum   | JSON:API type for DORA deployment events. Allowed enum values: `dora_deployment` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "id": "4242fcdd31586083",
    "type": "dora_deployment"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/dora/deployment" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "custom_tags": [
        "language:java",
        "department:engineering"
      ],
      "env": "staging",
      "finished_at": 1693491984000000000,
      "git": {
        "commit_sha": "66adc9350f2cc9b250b69abddab733dd55e1a588",
        "repository_url": "https://github.com/organization/example-repository"
      },
      "service": "test-service",
      "started_at": 1693491974000000000,
      "team": "backend",
      "version": "v1.12.07"
    }
  }
}
EOF 
                        
{% /tab %}
